#!/usr/local/bin/perl
#
# WinProxy log digger by CryptoManceR
# preliminary report generator
# http://cryptomancer.narod.ru
# cryptomancer@yandex.ru
#

@logs=<logs\\*.log>;

foreach $logname ( @logs )
{ open(FH,"$logname"); @log=<FH>; close(FH);
  foreach $l ( @log )
  {
    chomp($l); ($d,$t,$ip,$usr,$sid,$rt,$ut)=split(/\s+/,$l,7);
    unless (defined($rt)) { next; }; # skip over "service started" message
    
    if ($rt eq "Requested:") {
      if($ut =~ /^.+\:\/\/(.+?)\/.*$/) { $ut=$1; }
      $j{$sid}=join(" ",$ip,$ut);
    }

    if ($rt eq "Traffic") {
    ($txto,$rxfrom,$txfor,$rxfor,$sec)=split(/\t/,$ut);
  
    if ($rxfor>0) { $jhits{$j{$sid}}+=$rxfor; };
    delete $j{$sid};
    }

  }
}

open(CLOG,">clog.dat") || die "Can't write to cooked log file";
foreach $hit (sort {$jhits{$b} <=> $jhits{$a}}  keys %jhits) 
  { print CLOG "$hit $jhits{$hit} \n";};
close(CLOG);